   This file documents Gnus, the GNU Emacs newsreader.

   Copyright (C) 1995,96 Free Software Foundation, Inc.

   Permission is granted to make and distribute verbatim copies of this
manual provided the copyright notice and this permission notice are
preserved on all copies.

   Permission is granted to copy and distribute modified versions of
this manual under the conditions for verbatim copying, provided also
that the entire resulting derived work is distributed under the terms
of a permission notice identical to this one.

   Permission is granted to copy and distribute translations of this
manual into another language, under the above conditions for modified
versions.

Score File Syntax
-----------------

   Score files are meant to be easily parsable, but yet extremely
mallable.   It was decided that something that had the same read syntax
as an Emacs Lisp list would fit that spec.

   Here's a typical score file:

     (("summary"
       ("win95" -10000 nil s)
       ("Gnus"))
      ("from"
       ("Lars" -1000))
      (mark -100))

   BNF definition of a score file:

     score-file       = "" / "(" *element ")"
     element          = rule / atom
     rule             = string-rule / number-rule / date-rule
     string-rule      = "(" quote string-header quote space *string-match ")"
     number-rule      = "(" quote number-header quote space *number-match ")"
     date-rule        = "(" quote date-header quote space *date-match ")"
     quote            = <ascii 34>
     string-header    = "subject" / "from" / "references" / "message-id" /
                        "xref" / "body" / "head" / "all" / "followup"
     number-header    = "lines" / "chars"
     date-header      = "date"
     string-match     = "(" quote <string> quote [ "" / [ space score [ "" /
                        space date [ "" / [ space string-match-t ] ] ] ] ] ")"
     score            = "nil" / <integer>
     date             = "nil" / <natural number>
     string-match-t   = "nil" / "s" / "substring" / "S" / "Substring" /
                        "r" / "regex" / "R" / "Regex" /
                        "e" / "exact" / "E" / "Exact" /
                        "f" / "fuzzy" / "F" / "Fuzzy"
     number-match     = "(" <integer> [ "" / [ space score [ "" /
                        space date [ "" / [ space number-match-t ] ] ] ] ] ")"
     number-match-t   = "nil" / "=" / "<" / ">" / ">=" / "<="
     date-match       = "(" quote <string> quote [ "" / [ space score [ "" /
                        space date [ "" / [ space date-match-t ] ] ] ] ")"
     date-match-t     = "nil" / "at" / "before" / "after"
     atom             = "(" [ required-atom / optional-atom ] ")"
     required-atom    = mark / expunge / mark-and-expunge / files /
                        exclude-files / read-only / touched
     optional-atom    = adapt / local / eval
     mark             = "mark" space nil-or-number
     nil-or-number    = "nil" / <integer>
     expunge          = "expunge" space nil-or-number
     mark-and-expunge = "mark-and-expunge" space nil-or-number
     files            = "files" *[ space <string> ]
     exclude-files    = "exclude-files" *[ space <string> ]
     read-only        = "read-only" [ space "nil" / space "t" ]
     adapt            = "adapt" [ space "ignore" / space "t" / space adapt-rule ]
     adapt-rule       = "(" *[ <string> *[ "(" <string> <integer> ")" ] ")"
     local            = "local" *[ space "(" <string> space <form> ")" ]
     eval             = "eval" space <form>
     space            = *[ " " / <TAB> / <NEWLINE> ]

   Any unrecognized elements in a score file should be ignored, but not
discarded.

   As you can see, white space is needed, but the type and amount of
white space is irrelevant.  This means that formatting of the score
file is left up to the programmer--if it's simpler to just spew it all
out on one looong line, then that's ok.

   The meaning of the various atoms are explained elsewhere in this
manual (see Score File Format.).

Headers
-------

   Internally Gnus uses a format for storing article headers that
corresponds to the NOV format in a mysterious fashion.  One could
almost suspect that the author looked at the NOV specification and just
shamelessly *stole* the entire thing, and one would be right.

   "Header" is a severely overloaded term.  "Header" is used in RFC1036
to talk about lines in the head of an article (e.g., `From').  It is
used by many people as a synonym for "head"--"the header and the body".
(That should be avoided, in my opinion.)  And Gnus uses a format
internally that it calls "header", which is what I'm talking about
here.  This is a 9-element vector, basically, with each header (ouch)
having one slot.

   These slots are, in order: `number', `subject', `from', `date',
`id', `references', `chars', `lines', `xref'.  There are macros for
accessing and setting these slots--they all have predictable names
beginning with `mail-header-' and `mail-header-set-', respectively.

   The `xref' slot is really a `misc' slot.  Any extra info will be put
in there.

Ranges
------

   GNUS introduced a concept that I found so useful that I've started
using it a lot and have elaborated on it greatly.

   The question is simple: If you have a large amount of objects that
are identified by numbers (say, articles, to take a *wild* example)
that you want to qualify as being "included", a normal sequence isn't
very useful.  (A 200,000 length sequence is a bit long-winded.)

   The solution is as simple as the question: You just collapse the
sequence.

     (1 2 3 4 5 6 10 11 12)

   is transformed into

     ((1 . 6) (10 . 12))

   To avoid having those nasty `(13 . 13)' elements to denote a
lonesome object, a `13' is a valid element:

     ((1 . 6) 7 (10 . 12))

   This means that comparing two ranges to find out whether they are
equal is slightly tricky:

     ((1 . 5) 7 8 (10 . 12))

   and

     ((1 . 5) (7 . 8) (10 . 12))

   are equal.  In fact, any non-descending list is a range:

     (1 2 3 4 5)

   is a perfectly valid range, although a pretty long-winded one.  This
is also legal:

     (1 . 5)

   and is equal to the previous range.

   Here's a BNF definition of ranges.  Of course, one must remember the
semantic requirement that the numbers are non-descending.  (Any number
of repetition of the same number is allowed, but apt to disappear in
range handling.)

     range           = simple-range / normal-range
     simple-range    = "(" number " . " number ")"
     normal-range    = "(" start-contents ")"
     contents        = "" / simple-range *[ " " contents ] /
                       number *[ " " contents ]

   Gnus currently uses ranges to keep track of read articles and article
marks.  I plan on implementing a number of range operators in C if The
Powers That Be are willing to let me.  (I haven't asked yet, because I
need to do some more thinking on what operators I need to make life
totally range-based without ever having to convert back to normal
sequences.)

Group Info
----------

   Gnus stores all permanent info on groups in a "group info" list.
This list is from three to six elements (or more) long and exhaustively
describes the group.

   Here are two example group infos; one is a very simple group while
the second is a more complex one:

     ("no.group" 5 (1 . 54324))

     ("nnml:my.mail" 3 ((1 . 5) 9 (20 . 55))
                     ((tick (15 . 19)) (replied 3 6 (19 . 3)))
                     (nnml "")
                     (auto-expire (to-address "ding@gnus.org")))

   The first element is the "group name"--as Gnus knows the group,
anyway.  The second element is the "subscription level", which normally
is a small integer.  The third element is a list of ranges of read
articles.  The fourth element is a list of lists of article marks of
various kinds.  The fifth element is the select method (or virtual
server, if you like).  The sixth element is a list of "group
parameters", which is what this section is about.

   Any of the last three elements may be missing if they are not
required.  In fact, the vast majority of groups will normally only have
the first three elements, which saves quite a lot of cons cells.

   Here's a BNF definition of the group info format:

     info          = "(" group space level space read
                     [ "" / [ space marks-list [ "" / [ space method [ "" /
                     space parameters ] ] ] ] ] ")"
     group         = quote <string> quote
     level         = <integer in the range of 1 to inf>
     read          = range
     marks-lists   = nil / "(" *marks ")"
     marks         = "(" <string> range ")"
     method        = "(" <string> *elisp-forms ")"
     parameters    = "(" *elisp-forms ")"

   Actually that `marks' rule is a fib.  A `marks' is a `<string>'
consed on to a `range', but that's a bitch to say in pseudo-BNF.

   If you have a Gnus info and want to access the elements, Gnus offers
a series of macros for getting/setting these elements.

`gnus-info-group'
`gnus-info-set-group'
     Get/set the group name.

`gnus-info-rank'
`gnus-info-set-rank'
     Get/set the group rank.

`gnus-info-level'
`gnus-info-set-level'
     Get/set the group level.

`gnus-info-score'
`gnus-info-set-score'
     Get/set the group score.

`gnus-info-read'
`gnus-info-set-read'
     Get/set the ranges of read articles.

`gnus-info-marks'
`gnus-info-set-marks'
     Get/set the lists of ranges of marked articles.

`gnus-info-method'
`gnus-info-set-method'
     Get/set the group select method.

`gnus-info-params'
`gnus-info-set-params'
     Get/set the group parameters.

   All the getter functions take one parameter--the info list.  The
setter functions take two parameters--the info list and the new value.

   The last three elements in the group info aren't mandatory, so it
may be necessary to extend the group info before setting the element.
If this is necessary, you can just pass on a non-`nil' third parameter
to the three final setter functions to have this happen automatically.

Emacs/XEmacs Code
-----------------

   While Gnus runs under Emacs, XEmacs and Mule, I decided that one of
the platforms must be the primary one.  I chose Emacs.  Not because I
don't like XEmacs or Mule, but because it comes first alphabetically.

   This means that Gnus will byte-compile under Emacs with nary a
warning, while XEmacs will pump out gigabytes of warnings while
byte-compiling.  As I use byte-compilation warnings to help me root out
trivial errors in Gnus, that's very useful.

   I've also consistently used Emacs function interfaces, but have used
Gnusey aliases for the functions.  To take an example:  Emacs defines a
`run-at-time' function while XEmacs defines a `start-itimer' function.
I then define a function called `gnus-run-at-time' that takes the same
parameters as the Emacs `run-at-time'.  When running Gnus under Emacs,
the former function is just an alias for the latter.  However, when
running under XEmacs, the former is an alias for the following function:

     (defun gnus-xmas-run-at-time (time repeat function &rest args)
       (start-itimer
        "gnus-run-at-time"
        `(lambda ()
           (,function ,@args))
        time repeat))

   This sort of thing has been done for bunches of functions.  Gnus does
not redefine any native Emacs functions while running under XEmacs--it
does this `defalias' thing with Gnus equivalents instead.  Cleaner all
over.

   In the cases where the XEmacs function interface was obviously
cleaner, I used it instead.  For example `gnus-region-active-p' is an
alias for `region-active-p' in XEmacs, whereas in Emacs it is a
function.

   Of course, I could have chosen XEmacs as my native platform and done
mapping functions the other way around.  But I didn't.  The performance
hit these indirections impose on Gnus under XEmacs should be slight.

Various File Formats
--------------------

Active File Format
..................

   The active file lists all groups available on the server in
question.  It also lists the highest and lowest current article numbers
in each group.

   Here's an excerpt from a typical active file:

     soc.motss 296030 293865 y
     alt.binaries.pictures.fractals 3922 3913 n
     comp.sources.unix 1605 1593 m
     comp.binaries.ibm.pc 5097 5089 y
     no.general 1000 900 y

   Here's a pseudo-BNF definition of this file:

     active      = *group-line
     group-line  = group space high-number space low-number space flag <NEWLINE>
     group       = <non-white-space string>
     space       = " "
     high-number = <non-negative integer>
     low-number  = <positive integer>
     flag        = "y" / "n" / "m" / "j" / "x" / "=" group

Newsgroups File Format
......................

   The newsgroups file lists groups along with their descriptions.  Not
all groups on the server have to be listed,  and not all groups in the
file have to exist on the server.  The file is meant purely as
information to the user.

   The format is quite simple; a group name, a tab, and the description.
Here's the definition:

     newsgroups    = *line
     line          = group tab description <NEWLINE>
     group         = <non-white-space string>
     tab           = <TAB>
     description   = <string>

Emacs for Heathens
==================

   Believe it or not, but some people who use Gnus haven't really used
Emacs much before they embarked on their journey on the Gnus Love Boat.
If you are one of those unfortunates whom "`M-C-a'", "kill the region",
and "set `gnus-flargblossen' to an alist where the key is a regexp that
is used for matching on the group name" are magical phrases with little
or no meaning, then this appendix is for you.  If you are already
familiar with Emacs, just ignore this and go fondle your cat instead.

Keystrokes
----------

   * Q: What is an experienced Emacs user?

   * A: A person who wishes that the terminal had pedals.

   Yes, when you use Emacs, you are apt to use the control key, the
shift key and the meta key a lot.  This is very annoying to some people
(notably `vi'le users), and the rest of us just love the hell out of
it.  Just give up and submit.  Emacs really does stand for
"Escape-Meta-Alt-Control-Shift", and not "Editing Macros", as you may
have heard from other disreputable sources (like the Emacs author).

   The shift keys are normally located near your pinky fingers, and are
normally used to get capital letters and stuff.  You probably use it all
the time.  The control key is normally marked "CTRL" or something like
that.  The meta key is, funnily enough, never marked as such on any
keyboard.  The one I'm currently at has a key that's marked "Alt",
which is the meta key on this keyboard.  It's usually located somewhere
to the left hand side of the keyboard, usually on the bottom row.

   Now, us Emacs people don't say "press the meta-control-m key",
because that's just too inconvenient.  We say "press the `M-C-m' key".
`M-' is the prefix that means "meta" and "C-" is the prefix that means
"control".  So "press `C-k'" means "press down the control key, and
hold it down while you press `k'".  "Press `M-C-k'" means "press down
and hold down the meta key and the control key and then press `k'".
Simple, ay?

   This is somewhat complicated by the fact that not all keyboards have
a meta key.  In that case you can use the "escape" key.  Then `M-k'
means "press escape, release escape, press `k'".  That's much more work
than if you have a meta key, so if that's the case, I respectfully
suggest you get a real keyboard with a meta key.  You can't live without
it.

Emacs Lisp
----------

   Emacs is the King of Editors because it's really a Lisp interpreter.
Each and every key you tap runs some Emacs Lisp code snippet, and since
Emacs Lisp is an interpreted language, that means that you can configure
any key to run any arbitrary code.  You just, like, do it.

   Gnus is written in Emacs Lisp, and is run as a bunch of interpreted
functions.  (These are byte-compiled for speed, but it's still
interpreted.)  If you decide that you don't like the way Gnus does
certain things, it's trivial to have it do something a different way.
(Well, at least if you know how to write Lisp code.)  However, that's
beyond the scope of this manual, so we are simply going to talk about
some common constructs that you normally use in your `.emacs' file to
customize Gnus.

   If you want to set the variable `gnus-florgbnize' to four (4), you
write the following:

     (setq gnus-florgbnize 4)

   This function (really "special form") `setq' is the one that can set
a variable to some value.  This is really all you need to know.  Now
you can go and fill your `.emacs' file with lots of these to change how
Gnus works.

   If you have put that thing in your `.emacs' file, it will be read
and `eval'ed (which is lisp-ese for "run") the next time you start
Emacs.  If you want to change the variable right away, simply say `C-x
C-e' after the closing parenthesis.  That will `eval' the previous
"form", which is a simple `setq' statement here.

   Go ahead--just try it, if you're located at your Emacs.  After you
`C-x C-e', you will see `4' appear in the echo area, which is the
return value of the form you `eval'ed.

   Some pitfalls:

   If the manual says "set `gnus-read-active-file' to `some'", that
means:

     (setq gnus-read-active-file 'some)

   On the other hand, if the manual says "set `gnus-nntp-server' to
`nntp.ifi.uio.no'", that means:

     (setq gnus-nntp-server "nntp.ifi.uio.no")

   So be careful not to mix up strings (the latter) with symbols (the
former).  The manual is unambiguous, but it can be confusing.

   \input texinfo

Frequently Asked Questions
==========================

   This is the Gnus Frequently Asked Questions list.  If you have a Web
browser, the official hypertext version is at
`http://www.ccs.neu.edu/software/gnus/', and has probably been updated
since you got this manual.

Installation
------------

   * Q1.1  What is the latest version of Gnus?

     The latest (and greatest) version is 5.0.10.  You might also run
     across something called *September Gnus*.  September Gnus is the
     alpha version of the next major release of Gnus.  It is currently
     not stable enough to run unless you are prepared to debug lisp.

   * Q1.2  Where do I get Gnus?

     Any of the following locations:

        - `ftp://ftp.ifi.uio.no/pub/emacs/gnus/gnus.tar.gz'

        - `ftp://ftp.pilgrim.umass.edu/pub/misc/ding/'

        - `gopher://gopher.pilgrim.umass.edu/11/pub/misc/ding/'

        - `ftp://aphrodite.nectar.cs.cmu.edu/pub/ding-gnus/'

        - `ftp://ftp.solace.mh.se:/pub/gnu/elisp/'

   * Q1.3  Which version of Emacs do I need?

     At least GNU Emacs 19.28, or XEmacs 19.12 is recommended.  GNU
     Emacs 19.25 has been reported to work under certain circumstances,
     but it doesn't *officially* work on it.  19.27 has also been
     reported to work.  Gnus has been reported to work under OS/2 as
     well as Unix.

   * Q1.4  Where is timezone.el?

     Upgrade to XEmacs 19.13.  In earlier versions of XEmacs this file
     was placed with Gnus 4.1.3, but that has been corrected.

   * Q1.5  When I run Gnus on XEmacs 19.13 I get weird error messages.

     You're running an old version of Gnus.  Upgrade to at least version
     5.0.4.

   * Q1.6  How do I unsubscribe from the Mailing List?

     Send an e-mail message to `ding-request@ifi.uio.no' with the magic
     word *unsubscribe* somewhere in it, and you will be removed.

     If you are reading the digest version of the list, send an e-mail
     message to
     `ding-rn-digests-d-request@moe.shore.net' with *unsubscribe* as
     the subject and you will be removed.

   * Q1.7  How do I run Gnus on both Emacs and XEmacs?

     The basic answer is to byte-compile under XEmacs, and then you can
     run under either Emacsen.  There is, however, a potential version
     problem with easymenu.el with Gnu Emacs prior to 19.29.

     Per Abrahamsen <abraham@dina.kvl.dk> writes :
     The internal easymenu.el interface changed between 19.28 and 19.29
     in order to make it possible to create byte compiled files that
     can be shared between Gnu Emacs and XEmacs.  The change is upward
     compatible, but not downward compatible.  This gives the following
     compatibility table:

          Compiled with:  | Can be used with:
          ----------------+--------------------------------------
          19.28           | 19.28         19.29
          19.29           |               19.29           XEmacs
          XEmacs          |               19.29           XEmacs

     If you have Gnu Emacs 19.28 or earlier, or XEmacs 19.12 or
     earlier, get a recent version of auc-menu.el from
     `ftp://ftp.iesd.auc.dk/pub/emacs-lisp/auc-menu.el', and install it
     under the name easymenu.el somewhere early in your load path.

   * Q1.8 What resources are available?

     There is the newsgroup Gnu.emacs.gnus. Discussion of Gnus 5.x is
     now taking place there. There is also a mailing list, send mail to
     `ding-request@ifi.uio.no' with the magic word *subscribe*
     somewhere in it.

     *NOTE:* the traffic on this list is heavy so you may not want to be
     on it (unless you use Gnus as your mailer reader, that is). The
     mailing list is mainly for developers and testers.

     Gnus has a home World Wide Web page at
     `http://www.ifi.uio.no/~larsi/ding.html'.

     Gnus has a write up in the X Windows Applications FAQ at
     `http://www.ee.ryerson.ca:8080/~elf/xapps/Q-III.html'.

     The Gnus manual is also available on the World Wide Web. The
     canonical source is in Norway at
     `http://www.ifi.uio.no/~larsi/ding-manual/gnus_toc.html'.

     There are three mirrors in the United States:
       1. `http://www.miranova.com/gnus-man/'

       2.

          `http://www.pilgrim.umass.edu/pub/misc/ding/manual/gnus_toc.html'

       3. `http://www.rtd.com/~woo/gnus/'

     PostScript copies of the Gnus Reference card are available from
     `ftp://ftp.cs.ualberta.ca/pub/oolog/gnus/'.  They are mirrored at
     `ftp://ftp.pilgrim.umass.edu/pub/misc/ding/refcard/' in the United
     States. And
     `ftp://marvin.fkphy.uni-duesseldorf.de/pub/gnus/' in Germany.

     An online version of the Gnus FAQ is available at
     `http://www.miranova.com/~steve/gnus-faq.html'. Off-line formats
     are also available:
     ASCII: `ftp://ftp.miranova.com/pub/gnus/gnus-faq'
     PostScript: `ftp://ftp.miranova.com/pub/gnus/gnus-faq.ps'.

   * Q1.9  Gnus hangs on connecting to NNTP server

     I am running XEmacs on SunOS and Gnus prints a message about
     Connecting to NNTP server and then just hangs.

     Ben Wing <wing@netcom.com> writes :
     I wonder if you're hitting the infamous *libresolv* problem.  The
     basic problem is that under SunOS you can compile either with DNS
     or NIS name lookup libraries but not both.  Try substituting the
     IP address and see if that works; if so, you need to download the
     sources and recompile.

   * Q1.10  Mailcrypt 3.4 doesn't work

     This problem is verified to still exist in Gnus 5.0.9 and
     Mailcrypt 3.4.  The answer comes from Peter Arius
     <arius@immd2.informatik.uni-erlangen.de>.

     I found out that mailcrypt uses `gnus-eval-in-buffer-window',
     which is a macro.  It seems as if you have compiled mailcrypt with
     plain old GNUS in load path, and the XEmacs byte compiler has
     inserted that macro definition into `mc-toplev.elc'.  The solution
     is to recompile `mc-toplev.el' with Gnus 5 in load-path, and it
     works fine.

     Steve Baur <steve@miranova.com> adds :
     The problem also manifests itself if neither GNUS 4 nor Gnus 5 is
     in the load-path.

   * Q1.11  What other packages work with Gnus?

        - Mailcrypt.

          Mailcrypt is an Emacs interface to PGP.  It works, it installs
          without hassle, and integrates very easily.  Mailcrypt can be
          obtained from
          `ftp://cag.lcs.mit.edu/pub/patl/mailcrypt-3.4.tar.gz'.

        - Tools for Mime.

          Tools for Mime is an Emacs MUA interface to MIME.
          Installation is a two-step process unlike most other
          packages, so you should be prepared to move the byte-compiled
          code somewhere.  There are currently two versions of this
          package available.  It can be obtained from
          `ftp://ftp.jaist.ac.jp/pub/GNU/elisp/'.  Be sure to apply the
          supplied patch.  It works with Gnus through version 5.0.9.
          In order for all dependencies to work correctly the load
          sequence is as follows:
                 (load "tm-setup")
                 (load "gnus")
                 (load "mime-compose")

          *NOTE:* Loading the package disables citation highlighting by
          default.  To get the old behavior back, use the `M-t' command.

Customization
-------------

   * Q2.1  Custom Edit does not work under XEmacs

     The custom package has not been ported to XEmacs.

   * Q2.2  How do I quote messages?

     I see lots of messages with quoted material in them.  I am
     wondering how to have Gnus do it for me.

     This is Gnus, so there are a number of ways of doing this.  You
     can use the built-in commands to do this.  There are the `F' and
     `R' keys from the summary buffer which automatically include the
     article being responded to.  These commands are also selectable as
     Followup and Yank and Reply and Yank in the Post menu.

     `C-c C-y' grabs the previous message and prefixes each line with
     `ail-indentation-spaces' spaces or `mail-yank-prefix' if that is
     non-nil, unless you have set your own `mail-citation-hook', which
     will be called to do the job.

     You might also consider the Supercite package, which allows for
     pretty arbitrarily complex quoting styles.  Some people love it,
     some people hate it.

   * Q2.3 How can I keep my nnvirtual:* groups sorted?

     How can I most efficiently arrange matters so as to keep my
     nnvirtual:* (etc) groups at the top of my group selection buffer,
     whilst keeping everything sorted in alphabetical order.

     If you don't subscribe often to new groups then the easiest way is
     to first sort the groups and then manually kill and yank the
     virtuals wherever you want them.

   * Q2.4  Any good suggestions on stuff for an all.SCORE file?

     Here is a collection of suggestions from the Gnus mailing list.

       1. From "Dave Disser" <disser@sdd.hp.com>
          I like blasting anything without lowercase letters.  Weeds
          out most of the make $$ fast, as well as the lame titles like
          "IBM" and "HP-UX" with no further description.
                (("Subject"
                 ("^\\(Re: \\)?[^a-z]*$" -200 nil R)))

       2. From "Peter Arius" <arius@immd2.informatik.uni-erlangen.de>
          The most vital entries in my (still young) all.SCORE:
               (("xref"
                 ("alt.fan.oj-simpson" -1000 nil s))
                ("subject"
                 ("\\<\\(make\\|fast\\|big\\)\\s-*\\(money\\|cash\\|bucks?\\)\\>" -1000 nil r)
                 ("$$$$" -1000 nil s)))

       3. From "Per Abrahamsen" <abraham@dina.kvl.dk>
               (("subject"
                 ;; CAPS OF THE WORLD, UNITE
                 ("^..[^a-z]+$" -1 nil R)
                 ;; $$$ Make Money $$$ (Try work)
                 ("$" -1 nil s)
                 ;; I'm important! And I have exclamation marks to prove it!
                 ("!" -1 nil s)))

       4. From "heddy boubaker" <boubaker@cenatls.cena.dgac.fr>
          I  would like to contribute with mine.
               (
                (read-only t)
                ("subject"
                 ;; ALL CAPS SUBJECTS
                 ("^\\([Rr][Ee]: +\\)?[^a-z]+$" -1 nil R)
                 ;; $$$ Make Money $$$
                 ("$$" -10 nil s)
                 ;; Empty subjects are worthless!
                 ("^ *\\([(<]none[>)]\\|(no subject\\( given\\)?)\\)? *$" -10 nil r)
                 ;; Sometimes interesting announces occur!
                 ("ANN?OU?NC\\(E\\|ING\\)" +10 nil r)
                 ;; Some people think they're on mailing lists
                 ("\\(un\\)?sub?scribe" -100 nil r)
                 ;; Stop Micro$oft NOW!!
                 ("\\(m\\(icro\\)?[s$]\\(oft\\|lot\\)?-?\\)?wind?\\(ows\\|aube\\|oze\\)?[- ]*\\('?95\\|NT\\|3[.]1\\|32\\)" -1001 nil r)
                 ;; I've nothing to buy
                 ("\\(for\\|4\\)[- ]*sale" -100 nil r)
                 ;; SELF-DISCIPLINED people
                 ("\\[[^a-z0-9 \t\n][^a-z0-9 \t\n]\\]" +100 nil r)
                 )
                ("from"
                 ;; To keep track of posters from my site
                 (".dgac.fr" +1000 nil s))
                ("followup"
                 ;; Keep track of answers to my posts
                 ("boubaker" +1000 nil s))
                ("lines"
                 ;; Some people have really nothing to say!!
                 (1 -10 nil <=))
                (mark -100)
                (expunge -1000)
                )

       5. From "Christopher Jones" <cjones@au.oracle.com>
          The sample `all.SCORE' files from Per and boubaker could be
          augmented with:
               	(("subject"
               	  ;; No junk mail please!
               	  ("please ignore" -500 nil s)
               	  ("test" -500 nil e))
               	)

       6. From "Brian Edmonds" <edmonds@cs.ubc.ca>
          Augment any of the above with a fast method of scoring down
          excessively cross posted articles.
                ("xref"
                 ;; the more cross posting, the exponentially worse the article
                 ("^xref: \\S-+ \\S-+ \\S-+ \\S-+" -1 nil r)
                 ("^xref: \\S-+ \\S-+ \\S-+ \\S-+ \\S-+" -2 nil r)
                 ("^xref: \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+" -4 nil r)
                 ("^xref: \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+" -8 nil r)
                 ("^xref: \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+" -16 nil r)
                 ("^xref: \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+" -32 nil r)
                 ("^xref: \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+" -64 nil r)
                 ("^xref: \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+" -128 nil r)
                 ("^xref: \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+" -256 nil r)
                 ("^xref: \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+ \\S-+" -512 nil r))

   * Q2.5  What do I use to yank-through when replying?

     You should probably reply and followup with `R' and `F', instead
     of `r' and `f', which solves your problem.  But you could try
     something like:

          (defconst mail-yank-ignored-headers
            "^.*:"
            "Delete these headers from old message when it's inserted in a reply.")

   * Q2.6  I don't like the default WWW browser

     Now when choosing an URL Gnus starts up a W3 buffer, I would like
     it to always use Netscape (I don't browse in text-mode ;-).

       1. Activate `Customize...' from the `Help' menu.

       2. Scroll down to the `WWW Browser' field.

       3. Click `mouse-2' on `WWW Browser'.

       4. Select `Netscape' from the pop up menu.

       5. Press `C-c C-c'

     If you are using XEmacs then to specify Netscape do
            (setq gnus-button-url 'gnus-netscape-open-url)

   * Q2.7 What, if any, relation is between "ask-server" and "(setq
     gnus-read-active-file 'some)"?

     In order for Gnus to show you the complete list of newsgroups, it
     will either have to either store the list locally, or ask the
     server to transmit the list. You enable the first with

                  (setq gnus-save-killed-list t)

     and the second with

                  (setq gnus-read-active-file t)

     If both are disabled, Gnus will not know what newsgroups exists.
     There is no option to get the list by casting a spell.

   * Q2.8  Moving between groups is slow.

     Per Abrahamsen <abraham@dina.kvl.dk> writes:
     Do you call `define-key' or something like that in one of the
     summary mode hooks?  This would force Emacs to recalculate the
     keyboard shortcuts.  Removing the call should speed up `M-x
     gnus-summary-mode RET' by a couple of orders of magnitude.  You
     can use

          (define-key gnus-summary-mode-map KEY COMMAND)

     in your `.gnus' instead.

Reading News
------------

   * Q3.1  How do I convert my kill files to score files?

     A kill-to-score translator was written by Ethan Bradford
     <ethanb@ptolemy.astro.washington.edu>.  It is available from

     `http://baugi.ifi.uio.no/~larsi/ding-various/gnus-kill-to-score.el'.

   * Q3.2 My news server has a lot of groups, and killing groups is
     painfully slow.

     Don't do that then.  The best way to get rid of groups that should
     be dead is to edit your newsrc directly.  This problem will be
     addressed in the near future.

   * Q3.3  How do I use an NNTP server with authentication?

     Put the following into your .gnus:
           (add-hook 'nntp-server-opened-hook 'nntp-send-authinfo)

   * Q3.4  Not reading the first article.

     How do I avoid reading the first article when a group is selected?

       1. Use `RET' to select the group instead of `SPC'.

       2. `(setq gnus-auto-select first nil)'

       3. Luis Fernandes <elf@mailhost.ee.ryerson.ca>writes:
          This is what I use...customize as necessary...

               ;;; Don't auto-select first article if reading sources, or archives or
               ;;; jobs postings, etc. and just display the summary buffer
               (add-hook 'gnus-select-group-hook
               	  (function
               	   (lambda ()
               	     (cond ((string-match "sources" gnus-newsgroup-name)
               		    (setq gnus-auto-select-first nil))
               			   ((string-match "jobs" gnus-newsgroup-name)
               				(setq gnus-auto-select-first nil))
               		   ((string-match "comp\\.archives" gnus-newsgroup-name)
               		    (setq gnus-auto-select-first nil))
               		   ((string-match "reviews" gnus-newsgroup-name)
               		    (setq gnus-auto-select-first nil))
               		   ((string-match "announce" gnus-newsgroup-name)
               		    (setq gnus-auto-select-first nil))
               		   ((string-match "binaries" gnus-newsgroup-name)
               		    (setq gnus-auto-select-first nil))
               		   (t
               		    (setq gnus-auto-select-first t))))))

       4. Per Abrahamsen <abraham@dina.kvl.dk> writes:
          Another possibility is to create an `all.binaries.all.SCORE'
          file like this:

               ((local
                 (gnus-auto-select-first nil)))

          and insert
               	(setq gnus-auto-select-first t)

          in your `.gnus'.

   * Q3.5  Why aren't BBDB known posters marked in the summary buffer?

     Brian Edmonds <edmonds@cs.ubc.ca> writes:
     Due to changes in Gnus 5.0, `bbdb-gnus.el' no longer marks known
     posters in the summary buffer.  An updated version, `gnus-bbdb.el'
     is available at the locations listed below.  This package also
     supports autofiling of incoming mail to folders specified in the
     BBDB.  Extensive instructions are included as comments in the file.

     Send mail to `majordomo@edmonds.home.cs.ubc.ca' with the following
     line in the body of the message: *get misc gnus-bbdb.el*.

     Or get it from the World Wide Web:
     `http://www.cs.ubc.ca/spider/edmonds/gnus-bbdb.el'.

Reading Mail
------------

   * Q4.1 What does the message "Buffer has changed on disk" mean in a
     mail group?

     Your filter program should not deliver mail directly to your
     folders, instead it should put the mail into spool files.  Gnus
     will then move the mail safely from the spool files into the
     folders.  This will eliminate the problem.  Look it up in the
     manual, in the section entitled "Mail & Procmail".

   * Q4.2  How do you make articles un-expirable?

     I am using nnml to read news and have used
     `gnus-auto-expirable-newsgroups' to automagically expire articles
     in some groups (Gnus being one of them).  Sometimes there are
     interesting articles in these groups that I want to keep.  Is
     there any way of explicitly marking an article as un-expirable -
     that is mark it as read but not expirable?

     Use `u', `!', `d' or `M-u' in the summary buffer. You just remove
     the `E' mark by setting some other mark. It's not necessary to
     tick the articles.

   * Q4.3  How do I delete bogus nnml: groups?

     My problem is that I have various mail (nnml) groups generated
     while experimenting with Gnus. How do I remove them now? Setting
     the level to 9 does not help. Also `gnus-group-check-bogus-groups'
     does not recognize them.

     Removing mail groups is tricky at the moment. (It's on the to-do
     list, though.) You basically have to kill the groups in Gnus, shut
     down Gnus, edit the active file to exclude these groups, and
     probably remove the nnml directories that contained these groups
     as well. Then start Gnus back up again.

   * Q4.4  What happened to my new mail groups?

     I got new mail, but I have never seen the groups they should have
     been placed in.

     They are probably there, but as zombies. Press `A z' to list
     zombie groups, and then subscribe to the groups you want with `u'.
     This is all documented quite nicely in the user's manual.

   * Q4.5  Not scoring mail groups

     How do you *totally* turn off scoring in mail groups?

     Use an nnbabyl:all.SCORE (or nnmh, or nnml, or whatever) file
     containing:

          ((adapt ignore)
           (local (gnus-use-scoring nil))
           (exclude-files "all.SCORE"))